<?php

use Shaarli\Config\ConfigManager;

function auto_tag_plugin_init(ConfigManager $conf)
{
    // Configure keywords and tags based on provided rules
    $conf->setEmpty('plugins.AUTO_TAG_KEYWORDS', [
        'accessibility,accessibilité,web development,web design,html,css' => 'web',
        'accounting,comptabilité' => 'accounting',
        'addict,addiction,drugs,drogues,cigarettes,bonbons,dopamine,sucre,nicotine,hooked' => 'addiction',
        'adhd,tdah' => 'adhd',
        'alternative,alternatives,compatible,compatibles,migrated,migration' => 'alternatives',
        'ads,advertisements,publicités,spam' => 'ads',
        'anxi,anxiété,burnout,méditation,cardio' => 'health-and-wellness',
        'architecture,architectures' => 'architecture',
        'archive,archiving,archives,archivage' => 'archiving,archives',
        'art,arts' => 'culture',
        'ask hn,news.ycombinator.com/item,reddit.com/r/' => 'debate',
        'audio,audiofiles,fichiers audio' => 'audio',
        'autism,autisme,autist,autiste' => 'autism',
        'automation,automate,automatisation,automatic,scripting,terminal,bash script,script python,python script,lua,script shell,script bash,shell script' => 'scripting,automation',
        'beauty,beau,beauté,imperfection,imperfections' => 'beauty,imperfection',
        'belgian,belgium,belge,belgique' => 'belgium',
        'board game,board games,boardgame,jeu de société,jeux de société' => 'board-games,geek,wishlist',
        'bookmarks,favoris,signets' => 'bookmarks-management',
        'blogroll' => 'blogging,discovery,small-web',
        'browsers,navigateurs,web browsers' => 'web-browsers',
        'books,livre,livres,quatrième de couverture,roman,novel,reading-list' => 'reading-and-literature,wishlist,inspiration,culture',
        'robots.txt,bots,spam,crawling,ddos' => 'spam',
        'bruxelles,brussels' => 'brussels',
        'calm tech,calmness,calm,technologie calme' => 'calm-tech',
        'cheatsheet,cheat sheet,cheat-sheet,antisèche' => 'cheatsheet,guides-and-tips',
        'cleaning,nettoyage' => 'cleaning',
        'cloud,aws,amazon,cloudron' => 'cloud',
        'cloudron' => 'cloudron,hosting',
        '(comic),-comic-,comics,bandes dessinées' => 'comics,reading-and-literature,wishlist,culture,humor',
        'comparison,comparer, vs ,versus,comparatif,comparaison' => 'comparison',
        'communicate,communication,messaging,messenger,gmail,communiquer' => 'communication',
        'complex,impossible to solve,complicated,very difficult,complexe,compliqué' => 'complexity,its-complicated',
        'configure,configuration,paramétrer,paramétrage' => 'configuration',
        'database,databases,RDS,base de données' => 'databases',
        'data collection,collecte de données' => 'data-collection',
        'data transfer,transfert de données' => 'data-portability',
        'debug,troubleshoot,diagnose,résoudre,diagnostiquer,troubleshooting' => 'problem-solving,guides-and-tips,debugging',
        'degoogling,degoogle,degoogler,dégooglisation' => 'freedom',
        'design,designs' => 'design',
        'development workflow,devex,flux de développement' => 'devex',
        'disk,disque,disques' => 'storage',
        'distraction,procrastination,procrastine,procrastiner,glander' => 'procrastination',
        'diy,self-host,héberger soi-même,my personal,fait maison' => 'diy',
        'dns,network,tcp,wireshark,réseau' => 'network',
        'docker,docker-compose,docker compose,container,containers,k8s,eks,kubernetes,minikube,k3s,helm,openshift' => 'container-technology,devops',
        'documentation,docs,document,documentation technique' => 'documentation',
        'ses droits,legally,legalement,légal' => 'legal',
        'elixir,python,pip,rust,golang,programming,developer,software development,developers,développeurs' => 'software-development',
        'emulator,emulation,émulateur,émulation' => 'emulation',
        'entrepreneurship,entrepreneurs,entrepreneuriat' => 'business',
        'espresso,coffee,café' => 'coffee',
        'ethic,ethique,ethics' => 'ethics',
        'explor,going deep,exploration' => 'discovery',
        'fediverse,unsafe,liberté,fédivers' => 'privacy-and-security,freedom,social-media',
        'libre,free,liberté' => 'freedom',
        'logiciel libre,free software,logiciel gratuit,free to use' => 'free-software',
        'from home,remote work,work remote,travail à distance,télétravail' => 'remote-work',
        'big-tech,gafam,degoogling,degoogle,grandes entreprises technologiques' => 'big-tech',
        'game,jeu vidéo,game dev,jeux,jeux vidéo' => 'games,geek,culture,wishlist',
        'gamedev,building game,développement de jeux' => 'gamedev,games,geek,culture',
        'gender,homosexualité,hétérosexualité,les sexes,caractères sexuels' => 'gender',
        'gratuit,free' => 'free',
        'gitops,gitlab,github actions,devops,SRE,ci/cd,platform-engineering,ci pipeline,application deployment,dagger,renovatebot,dependabot,continuous integration,site reliability eng' => 'devops,automation',
        'git,gitlab,jujutsu,pijul,mercurial,svn,version control,contrôle de version' => 'version-control',
        'gpt,chatgpt,llm,llms,artificial intelligence,intelligence artificielle,IA' => 'ai',
        'hacking,piratage' => 'hacking',
        'health,healthy,nutrition,food,alimentation,nourriture,santé' => 'health-and-wellness,food',
        'humans,humains' => 'humans',
        'humor,humour' => 'humor',
        'inspiration,creativity,creative,inspiration,créativité' => 'inspiration',
        'leadership,staff engineering,gestion' => 'leadership',
        'lambic,gueuze,beer,bière,bières' => 'beer-and-brewing',
        'linux,ubuntu,debian,linux windows macos' => 'os',
        'list,index of,awesome,installation,GitHub - ,liste' => 'list,discovery',
        'low-tech,low tech,technologie simple' => 'low-tech',
        'markdown,text files,fichiers texte,plaintext,formats' => 'markdown,text-files,plaintext,formats',
        'merdification,enshittif,AI-generated,crapification,decline in quality,déclin de qualité' => 'enshittification',
        'monitoring,metrics,to monitor,surveillance,métriques' => 'monitoring,metrics',
        'movie,cinéma,cinema,film,films' => 'movies,culture,geek',
        'music,spotify,radios,webradios,soundtrack,bande originale,musique' => 'music',
        'newsletter,news' => 'newsletter,news,wishlist',
        'nostalg,nostalgie' => 'nostalgia',
        'obsidian,note taking,note-taking,knowledge manag,prise de notes,gestion de connaissances' => 'knowledge-management,note-taking',
        'open-source,open source,code source libre' => 'open-source,free',
        'optimize,optimization,speed up,an efficient,optimiser,optimisation' => 'optimization',
        'philosoph,philosophie' => 'philosophy',
        'photography,photos,photographie' => 'photography,photos',
        'podcast,podcasts' => 'podcast',
        'ego,narciss,narcissisme' => 'psychology,ego',
        'psycholog,psychologie' => 'psychology',
        'voting,politic,politique,vote' => 'politics',
        'python,logiciels en python' => 'python,software-development,code',
        'privatebin' => 'secrets',
        'programming languages,langages de programmation' => 'code,computer-languages',
        'publishing,publier,publication' => 'publishing',
        'quality,qualité' => 'quality',
        'recommandations,recommendation,conseils' => 'recommandations,recommendations',
        'recycling,sustainab,green web,climate,recyclage,web écologique,climat' => 'ecology',
        'religion,chretiens,bible,coran,islam,musulmans,croyants,athée,la foi,église' => 'religion',
        'reviews,critique,avis' => 'reviews',
        'rss,rss feed,miniflux,web reader,lecteur web' => 'content-aggregation,content-curation',
        'ruby,rails app,applications ruby' => 'ruby,software-development,code',
        'science,sciences' => 'science',
        'scripting,jq,curl,wget,script,bash' => 'scripting',
        'search engine,moteur de recherche' => 'search-engines',
        'security,permission,sécurité,secure,privacy,private,degoogl,gdpr,data protection,online tracking,user profiling,anonymo,anonymi,surveillance,malware,spyware,decentrali,secrets,privacy matters,vpn,passkey,protéger' => 'privacy-and-security',
        'simplicity,minimal,less,declutter,stopped using,simple,simplification,simplifier,reduction in,fewer,no longer needed,minimalisme,simplicité,réduction' => 'minimalism',
        'small web,indie web,indieweb,petit web' => 'small-web',
        'smartphone,android,mobile,phone,téléphone,portables' => 'mobile',
        'snippet,extrait de code' => 'code',
        'static site,static-site,site statique' => 'static-site,static-web',
        'teamwork,collaborat,équipe,cooperat,coordinat,travail équipe' => 'collaboration',
        'technology,technologie' => 'technology',
        'template,modèle' => 'template',
        'terminal,tools-and-resources' => 'terminal,tools-and-resources',
        'test,tester' => 'testing',
        'text-based,plaintext,markup language,markdown,plain text,basé sur du texte,langage balisé' => 'plaintext,minimalism,formats,text-files',
        'time to update,maintainers,tech-debt,legacy code,long term software,temps pour mettre à jour' => 'maintenance,tech-debt',
        'to do,to-do,à faire' => 'todo',
        'tool,resources,a script,outil,a collection,a catalog,awesome list,links,outils,ressources' => 'tools-and-resources',
        'training,course,conference talk,learning,homeschool,expert,specializ,tacit knowledge,tribal knowledge,formation,cours,conférence,apprentissage' => 'education',
        '.txt,text-based,fichiers txt' => 'text-files',
        'ui,interfaces utilisateur' => 'ui',
        'ux,the experience of,usable,uxer,user experience,expérience utilisateur' => 'ux',
        'vps,serveur privé virtuel' => 'cloud,vps,hosting',
        'web archive,web archiving,save any website,bookmarks,wayback machine,archive.org,archivebox,archive web' => 'web-archiving',
        'webring' => 'discovery,small-web,webring',
        'wordpress,personal website,blog roll,blogroll,blogosphere,webring,digital garden,to blog,blogs' => 'blogging,writing,publishing,culture',
        'work,travail' => 'work',
        'youtube.com,invidious,peertube,watch?v' => 'wishlist,video',
        'zoemp,zoemp.be' => 'zoemp'
    ]);
}

function fetch_page_content($url)
{
    $htmlContent = @file_get_contents($url);
    if ($htmlContent === false) {
        return '';
    }

    $htmlContent = preg_replace('/<(script|style|head|noscript)[^>]*>.*?<\/\1>/is', '', $htmlContent);
    return strip_tags($htmlContent);
}


function calculate_tags(array $keywordsToTags, array $searchContents): array
{
    $contextWeights = [
        'title' => 3,
        'url' => 3,
        'description' => 3,
        'existing' => 3,
        'content' => 1
    ];

    $tagScores = [];

    foreach ($keywordsToTags as $keywords => $tags) {
        $keywordList = explode(',', $keywords);
        foreach ($keywordList as $keyword) {
            $keyword = preg_quote(trim($keyword), '/');
            $regex = '/\b' . $keyword . '\b/i';

            foreach ($searchContents as $context => $content) {
                if (preg_match($regex, $content)) {
                    $tagList = explode(',', $tags);
                    foreach ($tagList as $tag) {
                        $tag = trim($tag);
                        if (!isset($tagScores[$tag])) {
                            $tagScores[$tag] = 0;
                        }
                        $tagScores[$tag] += $contextWeights[$context];
                    }
                }
            }
        }
    }

    return $tagScores;
}

function filter_and_limit_tags(array $tagScores, int $minScore = 2, int $maxTags = 7): array
{
    // Filter tags with a score greater than or equal to the minimum required
    $filteredTags = array_filter($tagScores, function ($score) use ($minScore) {
        return $score >= $minScore;
    });

    // Sort tags by descending score
    arsort($filteredTags);

    // Limit the number of tags to the maximum allowed
    return array_slice(array_keys($filteredTags), 0, $maxTags);
}

function apply_auto_tags(array $data, ConfigManager $conf): array
{
    if (empty($data['link']['url'])) {
        return $data;
    }
    $keywordsToTags = $conf->get('plugins.AUTO_TAG_KEYWORDS', []);
    $pageContent = fetch_page_content($data['link']['url']);

    $searchContents = [
        'title' => $data['link']['title'],
        'url' => $data['link']['url'],
        'description' => $data['link']['description'] ?? '',
        'existing' => implode(' ', explode(' ', $data['link']['tags'] ?? '')),
        'content' => $pageContent
    ];

    // Calculate scores for each tag
    $tagScores = calculate_tags($keywordsToTags, $searchContents);

    // Filter and limit tags
    $tagsToAdd = filter_and_limit_tags($tagScores);

    $tagsToAdd[] = 'auto-tagged'; // Added a fixed tag
    $existingTags = array_map('trim', explode(' ', $data['link']['tags']));
    $tagsToAdd = array_map('trim', $tagsToAdd);

    $data['link']['tags'] = trim(implode(' ', array_filter(array_unique(array_merge($existingTags, $tagsToAdd)))));

    return $data;
}

function hook_auto_tag_plugin_render_editlink(array $data, ConfigManager $conf): array
{
    if (!$data['link_is_new']) {
        //return $data; // Do not reapply for non-new links
    }

    return apply_auto_tags($data, $conf);
}

function hook_auto_tag_plugin_save_link(array $data, ConfigManager $conf): array
{
    return apply_auto_tags($data, $conf);
}